package com.css.simulation.resource.system.service;

import api.common.pojo.constants.DictConstants;
import api.common.pojo.param.system.ParameterParam;
import api.common.pojo.param.system.UserParam;
import api.common.pojo.po.system.ParameterPO;
import api.common.pojo.vo.system.ParameterVO;
import api.common.pojo.vo.system.UserVO;
import api.common.util.EncryptUtil;
import api.common.util.ObjectUtil;
import api.common.util.StringUtil;
import api.common.util.TimeUtil;
import com.css.simulation.resource.common.oauth.OauthParameter;
import com.css.simulation.resource.common.utils.AuthUtil;
import com.css.simulation.resource.common.utils.PageUtil;
import com.css.simulation.resource.common.utils.PoUtil;
import com.css.simulation.resource.system.mapper.ParameterMapper;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.security.NoSuchAlgorithmException;
import java.util.List;


@Service
public class ParameterService {

    @Autowired
    ParameterMapper parameterMapper;


    public PageInfo<ParameterVO> getParameterList(ParameterParam pageParam) {
        PageUtil.setPageInfo(pageParam);
        List<ParameterVO> list = parameterMapper.getParameterList(pageParam);
        return new PageInfo<>(list);
    }


    public ParameterVO getParamInfoById(ParameterPO paramPO) {
        String paramId = paramPO.getId();
        ParameterVO parameterVO = parameterMapper.getParamInfoById(paramId);
        return parameterVO;
    }

    public ParameterPO saveParameter(ParameterPO paramPO) {
        //重名校验param
        List<ParameterPO> list = parameterMapper.checkUsername(paramPO);
        if(ObjectUtil.isNotNull(list)){
            paramPO.setId(null);
            return paramPO;
        }
        String id = paramPO.getId();
        if(ObjectUtil.isNull(id)){//新增
            PoUtil.initAddPo(paramPO);
            paramPO.setId(StringUtil.getRandomUUID());
            parameterMapper.insert(paramPO);
        }else{ //更新
            PoUtil.initUpdatePo(paramPO);
            parameterMapper.update(paramPO);
        }
        return paramPO;
    }


    public int deleteById(ParameterPO parameterPO) {
        parameterPO.setIsDeleted(DictConstants.YES);
        parameterPO.setModifyUserId(AuthUtil.getCurrentUserId());
        parameterPO.setModifyTime(TimeUtil.getNowForMysql());
        int i = parameterMapper.deleteById(parameterPO);
        return i;
    }


    public List<UserVO> getUserInfo(UserParam userParam) {
        List<UserVO> list = parameterMapper.getUserInfo(userParam);
        return list;
    }

}
